#include "systemc.h"

class Module: sc_module {

public:
  void thread0()
  {
    event0.notify(SC_ZERO_TIME);
  }

  void thread1()
  {
    event1.notify(SC_ZERO_TIME);
  }

  void thread2()
  {
    event2.notify(SC_ZERO_TIME);

  }

  void thread3()
  {
    wait(event_and_list);
  }

  SC_HAS_PROCESS(Module);

  sc_event event0;
  sc_event event1;
  sc_event event2;
  sc_event_and_list event_and_list;

  Module(sc_module_name mn): sc_module(mn) {

    SC_THREAD(thread0);
    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);
  }

  void before_end_of_elaboration()
  {
    event_and_list &= event0;
    event_and_list &= event1;
    event_and_list &= event2;
  }
};


int sc_main(int argc, char **argv)
{
  Module m("m");
  sc_start();
  return 0;
}

