#ifndef INITIATORSOCKET_H_INCLUDED_
#define INITIATORSOCKET_H_INCLUDED_

#include <vector>

#include "class.h"
#include "socket.h"

#include "rose.h"

namespace risc {

class InitiatorSocket: public Socket {

public:

  /**
   * \brief default constructor
   */
  explicit InitiatorSocket(SgVariableDefinition *ast_node, Class *parent);

  void get_mapped_sockets(std::set<risc::Socket*> &mapped_sockets);

  /**
   * \brief register the nb_transport_bw method for this socket
   */
  void register_nb_transport_bw(SgFunctionDeclaration* func_decl);

  /**
   * \brief get the registered nb_transport_bw method
   */
  SgFunctionDeclaration* get_registered_nb_transport_bw();

private:
  /**
   * \brief Disabled copy constructor
   */
  InitiatorSocket(const InitiatorSocket &ip);

  /**
   * \brief registered method for nb_transport_bw_
   */
  SgFunctionDeclaration* registered_nb_transport_bw_;
};

typedef std::vector<InitiatorSocket*> InitiatorSocketVector;
typedef std::vector<InitiatorSocket*>::iterator InitiatorSocketVectorIter;
typedef std::vector<InitiatorSocket*>::const_iterator InitiatorSocketVectorConstIter;

}; // end namespace risc

#endif /* INITIATORSOCKET_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
