#include <iostream>
#include <set>
#include <string>
#include <algorithm>

#include "rose.h"

#include "risc.h"

int main(int argc, char* argv[])
{
  std::cout << std::endl << "START PROCESSING FILE: " __FILE__ << " ..." << std::endl;

  risc::Design d(argc,argv);

  std::vector<SgClassDefinition*> modules = risc::traverser::find_all_modules();

  for(std::vector<SgClassDefinition*>::iterator iter = modules.begin();
    iter != modules.end(); iter++) {
    std::cout << SageInterface::get_name(*iter) << std::endl;
  }

  std::cout << "================== (unparse end) ==================" << std::endl;

  std::cout << "END PROCESSING FILE: " __FILE__ << " ..." << std::endl << std::endl;

//return backend(d.project_); // old code, leads to linker failure
  return 0;                   // new code, skip backend compiler (RD, 05/31/18)
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
