#include "systemc.h"

class Interface: virtual public sc_interface
{
public:
  virtual void func(void) = 0;
};

class Channel:
  public sc_channel,
  public Interface
{
public:
  Channel(sc_module_name name):
    sc_channel(name)
  { }

  void func(void)
  {
    wait(SC_ZERO_TIME);
    x++;
    wait(SC_ZERO_TIME);
  }

private:
  int x;
};

class Module1: public sc_module {

public:

  sc_port<Interface> port_;

  SC_HAS_PROCESS(Module1);

  Module1(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    port_->func();
  }
};

class Module2: public sc_module {

public:

  sc_port<Interface> port_;

  SC_HAS_PROCESS(Module2);

  Module2(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    port_->func();
  }
};


class Top: public sc_module {

public:
  Module1 m1;
  Module2 m2;
  Channel c1;

  SC_HAS_PROCESS(Top);

  Top(sc_module_name mn):
    sc_module(mn),
    m1("m1"),
    m2("m2"),
    c1("c1")
  { }

  void before_end_of_elaboration()
  {
    m1.port_.bind(c1);
    m2.port_.bind(c1);
  }
};

int sc_main(int argc, char **argv)
{
  Top t("top");
  sc_start();

  return 0;
};
