// bug20190621.cc
// (was simics_top.cpp, noticed in preparation of Intel demos)

#include "systemc.h"

SC_MODULE(TOP) {
  SC_CTOR(TOP) {
    SC_THREAD(main);
  }

  void main() {

    // Idle for 0.5 seconds, allow for device to be reset
    wait(0.5, sc_core::SC_SEC); // original code by EA (seg-fault in RISC 053)
    wait(500, sc_core::SC_MS);  // temporary work-around by RD

    // other test cases...
    wait(SC_ZERO_TIME);
//  wait(0);	// Error: (E525) wait(n) is only valid for n > 0: n = 0
//  wait(0.0);	// Error: (E525) wait(n) is only valid for n > 0: n = 0
//  wait(42);	// TODO: wait for n clock cycles
//  wait(42.0);	// TODO: wait for n clock cycles
    wait(0, sc_core::SC_NS);
    wait(0.0, sc_core::SC_NS);
    wait(42, sc_core::SC_MS);
    wait(42.0, sc_core::SC_MS);
  }
};

int sc_main(int argc, char* argv[]) {
  TOP t("t");
  sc_time ExpectedWaitTime(1084, SC_MS);

  cout << "sc_max_time() is " << sc_max_time() << "\n";
  sc_start();
  cout << "Total wait time: " << sc_time_stamp() << "\n";
  assert(sc_time_stamp() == ExpectedWaitTime);
  return 0;
}
