// or_event1.cc:
//
// 06/25/18 RD   initial version (modified from and_event1.cc)

#include <stdio.h>
#include "systemc.h"

class Main_Block : public sc_module
{
    public:
	sc_event e1,e2;
	sc_event_or_list e;
	int a1,a2,a3;
        sc_time t1,t2,t3;

	void S1()
	{
		for(int i=0;i<10;i++){
			e1.notify(SC_ZERO_TIME);
                        //std::cout << "e1 notified" <<std::endl;
			wait(1,SC_NS);
			a1++;
		}
                t1 = sc_time_stamp();
	}

	void S2()
	{
		for(int i=0;i<10;i++){
			e2.notify(SC_ZERO_TIME);
                        //std::cout << "e2 notified" <<std::endl;
			wait(1,SC_NS);
			a2++;
		}
                t2 = sc_time_stamp();
	}

	void R()
	{	int i=0;
		printf("i=%d\n",i);
		for(;i<10;i++){
			wait(e);
			a3++;
                        //printf("i=%d\n",i);
		}
                t3 = sc_time_stamp();
	}

	void before_end_of_elaboration()
        {
		e |= e1;
		e |= e2;
	}

	Main_Block(sc_module_name name)
	: sc_module(name)
	{
		a1=0;
		a2=0;
		a3=0;
                t1=SC_ZERO_TIME;
                t2=SC_ZERO_TIME;
                t3=SC_ZERO_TIME;
		SC_THREAD(S1);
		SC_THREAD(S2);
		SC_THREAD(R);
	}
	SC_HAS_PROCESS(Main_Block);
};

int sc_main(int argc, char* argv[])
{
    Main_Block m("m");
    const sc_time expect1(10, SC_NS);
    const sc_time expect2(10, SC_NS);
    const sc_time expect3( 9, SC_NS);

    printf("or_event1 starts\n");
    sc_start();
    cout << m.a1 << " at " << m.t1.to_string() << ", "
         << m.a2 << " at " << m.t2.to_string() << ", "
         << m.a3 << " at " << m.t3.to_string() << endl;
    assert(m.a1==10);
    assert(m.a2==10);
    assert(m.a3==10);
    assert(m.t1 == expect1);
    assert(m.t2 == expect2);
    assert(m.t3 == expect3);
    printf("or_event1 done\n");
    return 0;
}

/* ex: set softtabstop=8 tabstop=8 shiftwidth=8 expandtab: */
